package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// ldap_apis api表
type LdapApis struct {
	Id       int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"` //
	Method   *string    `gorm:"default:'';" json:"method"`                       //
	Path     *string    `gorm:"default:'';" json:"path"`                         //
	Category *string    `gorm:"default:'';" json:"category"`                     //
	Remark   *string    `gorm:"default:'';" json:"remark"`                       //
	Creator  *string    `gorm:"default:'';" json:"creator"`                      //
	Ctime    *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"ctime"`     //
	Utime    *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"utime"`     //
}
type LdapApisModel struct {
	db   *gorm.DB
	name string
}

func NewLdapApisModel(db *gorm.DB) *LdapApisModel { return &LdapApisModel{db: db, name: "ldap_apis"} }
